package com.DVInc.TestURCap.impl;

import com.ur.urcap.api.contribution.InstallationNodeContribution;
import com.ur.urcap.api.contribution.installation.InstallationAPIProvider;
import com.ur.urcap.api.domain.data.DataModel;
import com.ur.urcap.api.domain.script.ScriptWriter;
import com.ur.urcap.api.domain.userinteraction.keyboard.KeyboardInputCallback;
import com.ur.urcap.api.domain.userinteraction.keyboard.KeyboardInputFactory;
import com.ur.urcap.api.domain.userinteraction.keyboard.KeyboardTextInput;

public class TestURCapInstallationNodeContribution implements InstallationNodeContribution{
	private final KeyboardInputFactory keyboardFactory;
	private final TestURCapInstallationNodeView view;
	private DataModel model;
	
	private static final String KEY_TEXTFIELDINPUT = "TestURCapTextFieldInput";
	private static final String DEFAULTVALUE_TEXTFIELDINPUT = "Default";
	
	public TestURCapInstallationNodeContribution(InstallationAPIProvider apiProvider, DataModel model, TestURCapInstallationNodeView view) {
		this.keyboardFactory = apiProvider.getUserInterfaceAPI().getUserInteraction().getKeyboardInputFactory();
		this.view = view;
		this.model = model;
	}

	@Override
	public void openView() {
		String storedValue = model.get(KEY_TEXTFIELDINPUT, DEFAULTVALUE_TEXTFIELDINPUT);
		System.out.println("In Openview(), value stored in DataModel: "+storedValue);
		view.setDataModelContentText(storedValue);
		
	}

	@Override
	public void closeView() {
	}

	@Override
	public void generateScript(ScriptWriter writer) {
	}
	
	public void setValueDuringInitializing() {
		String newModelValue = "Set after Initializing";
		System.out.println("In method setValueDuringInitializin(), is key textFieldInput set in model?: "+Boolean.toString(model.isSet(KEY_TEXTFIELDINPUT)));
		System.out.println("In method setValueDuringInitializin(), value stored in dataModel: "+model.get(KEY_TEXTFIELDINPUT, DEFAULTVALUE_TEXTFIELDINPUT));
		model.set(KEY_TEXTFIELDINPUT, newModelValue);
		System.out.println("In method setValueDuringInitializin(), new value stored in dataModel: "+model.get(KEY_TEXTFIELDINPUT, DEFAULTVALUE_TEXTFIELDINPUT));
	}
	
	
	public KeyboardTextInput getKeyboardTextInput() {
		return keyboardFactory.createStringKeyboardInput();
	}
	
	public KeyboardInputCallback<String> getKeyboardTextInputCallback() {
		return new KeyboardInputCallback<String>() {
			@Override
			public void onOk(String value) {
				view.setInputFieldText(value);
				model.set(KEY_TEXTFIELDINPUT, value);
			}
			
		};
	}

}
